<template>
  <q-card class="card" :class="{ selected: selected }" @mousedown="handleMouseDown" :style="block_style">
    <q-icon class="badge" color="negative" name="warning" v-if="!ready" />
    <div class="side-menu column justify-start">
      <q-btn
        v-show="selected"
        icon="clear"
        size="sm"
        round
        push
        color="white"
        text-color="negative"
        @click="handleDelete"
      />
      <q-btn
        v-show="selected"
        icon="edit"
        size="sm"
        round
        push
        color="white"
        text-color="positive"
        @click="handle_edit"
      />
    </div>
    <q-card-section class="column">
      <span class="text-overline text-right family-section" :style="title_style">
        {{ block.family }}
      </span>
      <span class="text-h6 text-left text-weight-medium name-section nunito">
        {{ name }}
      </span>
      <div class="text-center">
        <q-img :src="image_path" contain="fit" class="image-section">
          <template v-slot:error>
            <q-img :src="fallback_image_path" contain="fit" class="absolute-full flex flex-center bg-white" />
          </template>
        </q-img>
      </div>
    </q-card-section>

    <div
      class="node-port node-input"
      @mousedown="inputMouseDown(index, $event)"
      @mouseup="inputMouseUp(index, $event)"
      v-for="(input, index) in $props.block.inputs"
      :key="'input' + index"
      :style="input_slot_style(index)"
    >
      <q-tooltip
        v-if="input.name.length > 0"
        anchor="center left"
        self="center right"
        :offset="[10, 10]"
        class="text-body2"
      >
        <strong>{{ input.name }}</strong>
      </q-tooltip>
    </div>
    <div
      class="node-port node-output"
      @mousedown="outputMouseDown(index, $event)"
      v-for="(output, index) in $props.block.outputs"
      :key="'output' + index"
      :style="output_slot_style(index)"
    >
      <q-tooltip
        v-if="output.name.length > 0"
        anchor="center right"
        self="center left"
        :offset="[10, 10]"
        class="text-body2"
      >
        <strong>{{ output.name }}</strong>
      </q-tooltip>
    </div>
  </q-card>
</template>

<script lang="ts">
import { defineComponent, PropType, computed, ref } from 'vue';
import { Point2D, RefinedBlock, BlockOptions } from 'src/models/workflow';

export default defineComponent({
  name: 'Block',
  emits: ['selected', 'delete', 'edit', 'linking_start', 'linking_stop', 'linking_break'],
  props: {
    block: {
      type: Object as PropType<RefinedBlock>,
      default: {
        id: '',
        name: '',
        family: '',
        position: { x: 0, y: 0 },
        inputs: [],
        outputs: [],
        loggable: {},
        data: {},
      } as RefinedBlock,
    },
    options: {
      type: Object as PropType<BlockOptions>,
      default: <BlockOptions>{
        center: {
          x: 0,
          y: 0,
        },
        selected: '',
      },
    },
  },

  setup(props, { emit }) {
    const selected = computed(() => {
      return props.options.selected === props.block.id;
    });

    const name = computed(() => {
      const _name = props.block.name;
      return _name.length > 13 ? _name.slice(0, 15) + '.' : _name;
    });

    const bg_color = ref('#000000');
    switch (props.block.family) {
      case 'controller':
        bg_color.value = '#2980b9';
        break;
      case 'reference':
        bg_color.value = '#1abc9c';
        break;
      case 'testbed':
        bg_color.value = '#343434';
        break;
    }

    const title_style = computed(() => {
      return {
        color: bg_color.value,
      };
    });

    const input_slot_style = (index: number) => {
      const height = 140;
      const step = height / (props.block.inputs.length + 1);
      return {
        top: `${(index + 1) * step}px`,
        left: '0px',
        '--bg-color': bg_color.value,
      };
    };
    const output_slot_style = (index: number) => {
      const width = 150;
      const height = 140;
      const step = height / (props.block.outputs.length + 1);
      return {
        top: `${(index + 1) * step}px`,
        left: `${width}px`,
        '--bg-color': bg_color.value,
      };
    };

    let image_path = `workflow/${props.block.family}/${props.block.name.toLowerCase()}.svg`;
    let fallback_image_path = `workflow/${props.block.family}/fallback.svg`;

    if (props.block.family === 'testbed') {
      image_path = `workflow/testbed/testbed${props.block.inputs.length}.svg`;
    }

    const ready = computed(() => {
      return !Object.values(props.block.data).some((x) => x === null || x.toString() === '');
    });

    const nodeStyleFunc = (center: Point2D, position: Point2D) => {
      return {
        top: `${center.y + position.y}` + 'px',
        left: `${center.x + position.x}` + 'px',
      };
    };

    const block_style = computed(() => nodeStyleFunc(props.options.center, props.block.position));

    function handleMouseDown(e: MouseEvent) {
      const target = e.target as HTMLElement;
      if (target.className.indexOf('node-input') < 0 && target.className.indexOf('node-output') < 0)
        emit('selected', e);
      e.preventDefault();
    }

    function outputMouseDown(index: number, e: MouseEvent) {
      emit('linking_start', index);
      e.preventDefault();
    }
    function inputMouseDown(index: number, e: MouseEvent) {
      emit('linking_break', index);
      e.preventDefault();
    }
    function inputMouseUp(index: number, e: MouseEvent) {
      emit('linking_stop', index);
      e.preventDefault();
    }

    function handleDelete() {
      emit('delete');
    }

    const handle_edit = () => {
      emit('edit');
    };

    return {
      name,
      title_style,
      handleMouseDown,
      block_style,
      image_path,
      fallback_image_path,
      handleDelete,
      handle_edit,
      selected,
      outputMouseDown,
      inputMouseDown,
      inputMouseUp,
      ready,
      input_slot_style,
      output_slot_style,
    };
  },
});
</script>

<style lang="sass" scoped>
$portSize: 11

.card
  height: 140px
  width: 150px
  margin: 0
  position: absolute
  box-sizing: border-box
  background: white
  z-index: 1
  opacity: 1
  cursor: move
  transform-origin: top left
  border-radius: 7.5%

  .node-port
    position: absolute
    width: #{$portSize}px
    height: #{$portSize}px
    transform: translate(-50%, -50%)
    border: 1px solid #ccc
    border-radius: 100px
    background: white
    &:hover
      background: var(--bg-color)
      border: 1px solid var(--bg-color)
      animation: 0.5s grow forwards

  .node-output
    bottom: #{-2+$portSize/-2}px

  .node-input
    top: #{-2+$portSize/-2}px

  .side-menu
    position: absolute
    height: inherit
    right: -48px
    top: -48px
    z-index: 1

    .q-btn
      margin-top: 14px
      &:hover
        transform: scale(1.4)

  .column
    padding-top: 0px
    padding-right: 8px
    padding-left: 8px

  .family-section
    height: 20px
    overflow: hidden

  .name-section
    height: 32px
    display: inline

  .image-section
    max-width: 60%
    height: 80px
    object-fit: contain

  .badge
    position: absolute
    left: -18px
    top: -18px
    font-size: 36px

.selected
  z-index: 2

@keyframes grow
  0%
    transform: translate(-50%, -50%) scale(1)
  100%
    transform: translate(-50%, -50%) scale(2)
</style>
